package net.minecraft.thKaguyaMod;

import net.minecraft.*;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import java.util.List;
import java.util.Random;
import net.minecraft.item.ItemStack;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagDouble;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

public class EntitySilverKnife extends Entity
{
	//銀のナイフ　
	
	public short color;//ナイフの色
	private double speed;
	private int xTile;
    private int yTile;
    private int zTile;
    private int inTile;
	private int inData;
    private boolean inGround;
    public EntityLiving shootingEntity;
	public EntityLiving playerEntity;
    private int ticksAlive;
	private int ticksInGround;
    private int ticksInAir;
    public double accelerationX;
    public double accelerationY;
    public double accelerationZ;
	//protected String texture;
	private boolean hit;//衝突済み判定
	private boolean rockhit;//刺さらないブロックの上に乗っているかの判定
	
	private float rotationYaw2;
	private float rotationPitch2;
	public float angleZ;

	//ワールド読み込み時に呼び出されるコンストラクト
    public EntitySilverKnife(World par1World)
    {
        super(par1World);
        xTile = -1;
        yTile = -1;
        zTile = -1;
        inTile = 0;
    	inData = 0;
        inGround = false;
        ticksInAir = 0;
    	yOffset = 0.0F;
        setSize(0.1F, 0.1F);
    	
    }

    public boolean isInRangeToRenderDist(double d)
    {
        double d1 = boundingBox.getAverageEdgeLength() * 4D;
        d1 *= 64D;
        return d < d1 * d1;
    }

    public EntitySilverKnife(World par1World, EntityLiving entityliving, double xVector, double yVector, double zVector,double speed, int t)
    {
        super(par1World);
    	color = (short)t;//ナイフの色を保存
    	setKnifeColor(color);
        xTile = -1;
        yTile = -1;
        zTile = -1;
        inTile = 0;
    	inData = 0;
        inGround = false;
        ticksInAir = 0;
    	hit = false;
        shootingEntity = entityliving;
    	playerEntity = entityliving;
        setSize(0.1F, 0.1F);
    	speed = 2.0;
    	motionX = xVector;
    	motionY = yVector;
    	motionZ = zVector;
    	setKnifeZAngle(90.0F);
		rotationYaw = (float)Math.atan2(motionX, -motionZ) / 3.141593F * 180F;
    	rotationPitch = (float)Math.atan2(motionY, Math.sqrt(motionX * motionX + motionZ * motionZ)) / 3.141593F * 180F;
    	setLocationAndAngles(	entityliving.posX + motionX,
    							entityliving.posY + motionY + (double)entityliving.getEyeHeight() - 0.10000000149011612D,
    							entityliving.posZ + motionZ,
    							rotationYaw, rotationPitch);
    	prevPosX = entityliving.posX;
    	prevPosY = entityliving.posY;
    	prevPosZ = entityliving.posZ;
        yOffset = 0.0F;
    }
	
	//Entity生成時に一度だけ呼ばれる
	@Override
    protected void entityInit()
    {
    	dataWatcher.addObject(19, new Integer(0));
    	dataWatcher.addObject(20, new Integer(0));
    }

	
	//速度を返す
	public double getEntitySpeed()
	{
		double xx, yy, zz;
		xx = motionX;
		yy = motionY;
		zz = motionZ;
		return Math.sqrt(xx*xx + yy*yy + zz*zz);
	}
	
	@Override
    public void onUpdate()
    {
        super.onUpdate();
    	//生まれて2フレーム目なら
    	if(ticksExisted == 1)
    	{
    		//加速を設定
    		accelerationX = (motionX/2.0);
        	accelerationY = (motionY/2.0);
        	accelerationZ = (motionZ/2.0);
    	}
    	//2フレーム目でなく、300フレーム目でかつ衝突していないなら
    	else if(hit == false && ticksExisted == 300)
    	{
    		if(!worldObj.isRemote)
    		{
    			setDead();//消滅させる
    		}
    	}
    	rockhit = false;//硬いブロックと衝突しているかの判定変数
    	
    	//***
    	int i = worldObj.getBlockId(xTile, yTile, zTile);//現在地のブロックを取得
    	if (i > 0)
        {
            Block.blocksList[i].setBlockBoundsBasedOnState(worldObj, xTile, yTile, zTile);
            AxisAlignedBB axisalignedbb = Block.blocksList[i].getCollisionBoundingBoxFromPool(worldObj, xTile, yTile, zTile);

            if (axisalignedbb != null && axisalignedbb.isVecInside(worldObj.getWorldVec3Pool().getVecFromPool(this.posX, this.posY, this.posZ)))
            {
                inGround = true;
            }
        }
    	//***//
    	
    	//地面の中なら
        if (inGround)
        {
        	//現在地のブロックIDを取得
            int j = worldObj.getBlockId(xTile, yTile, zTile);
        	//現在地のブロックのメタデータを取得
            int k = worldObj.getBlockMetadata(xTile, yTile, zTile);
            if (j != inTile || k != inData)
            {
                inGround = false;
                motionX *= rand.nextFloat() * 0.2F;
                motionY *= rand.nextFloat() * 0.2F;
                motionZ *= rand.nextFloat() * 0.2F;
            	ticksInGround = 0;
                ticksInAir = 0;
            	ticksExisted = 3;
            }
			else
        	{
        		ticksInGround++;//地中カウンタを増やす

            	if (ticksInGround == 3000)//地中カウンタが3000なら消滅
            	{
            		if(!worldObj.isRemote)
            		{
                		setDead();
            		}
            	}
        	}

            return;//これ以上の処理は行わない
        }
        else
        {
        	//地面の中でないなら、空中カウンタを増やす
            ticksInAir++;
        }
    	
    	//始点を登録
    	Vec3 vec3d = worldObj.getWorldVec3Pool().getVecFromPool(this.posX, this.posY, this.posZ);
    	//終点を登録
    	Vec3 vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(this.posX + this.motionX, this.posY + this.motionY, this.posZ + this.motionZ);
        //始点と終点からブロックとの衝突を取得
    	MovingObjectPosition movingObjectPosition = worldObj.rayTraceBlocks(vec3d, vec3d1);
    	vec3d = worldObj.getWorldVec3Pool().getVecFromPool(this.posX, this.posY, this.posZ);
    	vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(this.posX + this.motionX, this.posY + this.motionY, this.posZ + this.motionZ);
        //ブロックと衝突していたなら
    	if (movingObjectPosition != null)
        {
        	//終点を衝突した点に変更
        	vec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(movingObjectPosition.hitVec.xCoord, movingObjectPosition.hitVec.yCoord, movingObjectPosition.hitVec.zCoord);
        }
        Entity entity = null;
    	//このEntityから移動後までの線分に、指定分の範囲を追加した直方体と衝突するEntityのリストを取得
        List list = worldObj.getEntitiesWithinAABBExcludingEntity(this, boundingBox.addCoord(motionX, motionY, motionZ).expand(0.01D, 0.01D, 0.01D));
        double d = 0.0D;
        for (int j = 0; j < list.size(); j++)
        {
        	// 衝突リストから、i番目のEntityを取得
            Entity entity1 = (Entity)list.get(j);
        	//そのEntityが衝突しないEntityか、ナイフを投げたEntityか、これのticksInAirが25以下なら、このEntityはパスする
            /*if ( !entity1.canBeCollidedWith() || entity1.isEntityEqual(playerEntity)) //&& ticksInAir < 25)
    		{
                continue;
            }*/
    		if(entity1.canBeCollidedWith() && entity1 != shootingEntity && ticksInAir >= 5)
    		{
        		float f2 = 0.3F;
            	AxisAlignedBB axisalignedbb = entity1.boundingBox.expand(f2, f2, f2);
            	MovingObjectPosition movingObjectPosition1 = axisalignedbb.calculateIntercept(vec3d, vec3d1);
        		//Entityとの衝突がないなら、このEntityはパスする
            	if (movingObjectPosition1 != null)
            	{
        			//始点からEntityに衝突した点までの距離を取得
            		double d1 = vec3d.distanceTo(movingObjectPosition1.hitVec);
        			//今までで一番近いEntityなら、Entityと距離を記憶する
            		if (d1 < d || d == 0.0D)
            		{		
                		entity = entity1;
                		d = d1;
            		}
            	}
            }
        }

    	//Entityに当たっていたなら
        if (entity != null)
        {
            movingObjectPosition = new MovingObjectPosition(entity);
        }
    	
    	if (movingObjectPosition != null && movingObjectPosition.entityHit != null && movingObjectPosition.entityHit instanceof EntityPlayer)
        {
        	EntityPlayer entityPlayer = (EntityPlayer)movingObjectPosition.entityHit;

            if (entityPlayer.capabilities.disableDamage || this.shootingEntity instanceof EntityPlayer && !((EntityPlayer)this.shootingEntity).func_96122_a(entityPlayer))
            {
            	movingObjectPosition = null;
            }
        }
    	
    	if (movingObjectPosition != null)
        {
        	//Entityに当たっていたなら
            if (movingObjectPosition.entityHit != null)
            {
            	//当たったEntityがEntitySilverKnifeに属していなければ
            	if(!(movingObjectPosition.entityHit instanceof EntitySilverKnife)  )
            	{
            		//衝突処理
            		onImpact(movingObjectPosition);
            		//
	                float f1 = MathHelper.sqrt_double(motionX * motionX + motionY * motionY + motionZ * motionZ);

	                //DamageSource damagesource = null;
					
            		//ナイフが燃えているなら、当たったEntityも着火
            		//ん？これいらんよな
	                if (isBurning())
	                {
	                    movingObjectPosition.entityHit.setFire(5);
	                }
            		//ナイフの動きを鈍らせ、逆方向に働かせる
	                motionX *= -0.210000000149011612D;
	                motionY *= -0.210000000149011612D;
	                motionZ *= -0.210000000149011612D;
            		accelerationX *= -0.01;
            		accelerationY *= -0.01;
            		accelerationZ *= -0.01;
            		speed *= -0.01;
	                rotationYaw += 180F;
	                prevRotationYaw += 180F;
            		//空中カウンタをリセット
	                ticksInAir = 0;
            		//生存カウンタを3まで戻す
            		ticksExisted = 3;
            		//衝突チェックをtrueにする
	                hit = true;
            		setKnifeZAngle(0.0F);
            	}
            	//当たったEntityが銀のナイフなら
            	else
            	{
            		//motionX *= 0.510000000149011612D;
	                //motionY *= 0.510000000149011612D;
	                //motionZ *= 0.510000000149011612D;
            		//accelerationX *= -0.01;
            		//accelerationY *= -0.01;
            		//accelerationZ *= -0.01;
            		//speed *= 0.01;
	                //rotationYaw += 180F;
	                //prevRotationYaw += 180F;
            		//ticksExisted = 3;
	                //ticksInAir = 0;
	                //hit = false;
            	}
            }
            	
            xTile = movingObjectPosition.blockX;
            yTile = movingObjectPosition.blockY;
            zTile = movingObjectPosition.blockZ;
            inTile = worldObj.getBlockId(xTile, yTile, zTile);
            inData = worldObj.getBlockMetadata(xTile, yTile, zTile);
            //当たったブロックの材質を取得
            Material material = worldObj.getBlockMaterial(xTile, yTile, zTile);
            //当たったブロックの材質が、rock,iron,glass,iceなら
            if( (material == Material.rock || material == Material.iron || material == Material.glass || material == Material.ice) )
            {
            	//速度が遅すぎでなければ
            	if(Math.abs(getEntitySpeed()) > 0.08F)
            	{
            		//当たったのがブロック、または、EntitySilverKnifeに属しているなら
            		if(movingObjectPosition.entityHit == null || movingObjectPosition.entityHit instanceof EntitySilverKnife)
            		{
            			//衝突時の金属音のような音を出す
            			worldObj.playSoundAtEntity(this, "random.orb", 0.5F, 5.0F);
            		}
	            	//motionX *= -0.050000000149011612D;//移動方向を逆にする
	                //motionY *= -0.050000000149011612D;
	                //motionZ *= -0.050000000149011612D;
            		//当たったのがEntitySilverKnifeに属しているなら
            		if(movingObjectPosition.entityHit instanceof EntitySilverKnife)
            		{
            			//衝突処理をし、少しランダムに向きを変える
            			Random rand = new Random();
            			float randangle = (float)rand.nextInt(120);
            			rotationYaw += 165.0F - 15.0F + randangle;
            			motionX += MathHelper.sin(randangle);
            			motionZ += MathHelper.cos(randangle);
            			motionX *= -0.050000000149011612D*Math.sin(randangle);//移動方向を逆にする
	                    motionY *= -0.050000000149011612D;
            			motionZ *= -0.050000000149011612D*Math.cos(randangle);
            			accelerationX *= -0.01;
	            		accelerationZ *= -0.01;
            			//このナイフと当たったナイフの上下関係で速度に変化が出る
            			if(posY > movingObjectPosition.entityHit.posY)
            			{
            				accelerationY *= -0.01;
            			}
            			else
            			{
            				accelerationY *= -0.5;
            			}
	            		speed *= 0.01;
            		}
            		//硬いブロックに当たっているなら
            		else
            		{
            			//青のナイフなら
            			/*if(getKnifeColor() == 0 || Math.abs(getEntitySpeed()) < 0.2D )
            			{
            				motionX *= -0.050000000149011612D;//移動方向を逆にする
	                		motionY *= -0.050000000149011612D;
	                		motionZ *= -0.050000000149011612D;
            				accelerationX *= -0.01;
	            			accelerationY *= -0.01;
	            			accelerationZ *= -0.01;
	            			speed *= 0.01;
	            			rotationYaw += 180F;//向きを180度変える
            			}
            			//青以外なら
            			else
            			{*/
            				double returnRate = 0.25D * getEntitySpeed();
            				if(getKnifeColor() == 0)
            				{
            					returnRate = 0.01D;
            				}
            				//float supDis = MathHelper.sqrt_double(motionX * motionX + motionY * motionY + motionZ * motionZ);//当たったブロックとナイフの距離
	            			//posX -= (motionX / (double)supDis) * 0.05000000074505806D;//めり込んだ分だけ引き戻し
	            			//posY -= (motionY / (double)supDis) * 0.05000000074505806D;
	            			//posZ -= (motionZ / (double)supDis) * 0.05000000074505806D;
            				double supPosX1 = posX;
            				double supPosX2 = posX + motionX;
            				double supPosY1 = posY;
            				double supPosY2 = posY + motionY;
            				double supPosZ1 = posZ;
            				double supPosZ2 = posZ + motionZ;
            				//始点を登録
            				Vec3 supVec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX1, supPosY1, supPosZ1);
    						//終点を登録
    						Vec3 supVec3d2 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX2, supPosY2, supPosZ2);
        					//始点と終点からブロックとの衝突を取得
    						MovingObjectPosition supMovingObjectPosition = worldObj.rayTraceBlocks(supVec3d1, supVec3d2);
            				while(supMovingObjectPosition != null)
            				{
            					returnRate = 0.25D * getEntitySpeed();
            					if(getKnifeColor() == 0)
            					{
            						returnRate = 0.00001D;
            					}
	            				switch(supMovingObjectPosition.sideHit)
	            				{
	            					case 0:
	            						motionY *= -returnRate;
	            						accelerationY *= -returnRate;
	            						break;
	            					case 1:
	            						motionY *= -returnRate;
	            						accelerationY *= -returnRate;
	            						if(motionY < 0.2D)
	            						{
	            							motionX *= 0.3D;
	            							motionZ *= 0.3D;
	            						}
	            						if(getKnifeZAngle() > 0.0F)
	            						{
	            							setKnifeZAngle(getKnifeZAngle() - 21.0F);
	            						}
	            						else
	            						{
	            							setKnifeZAngle(0.0F);
	            						}
	            						break;
	            					case 2:
	            						motionZ *= -returnRate;
	            						accelerationZ *= -returnRate;
	            						break;
	            					case 3:
	            						motionZ *= -returnRate;
	            						accelerationZ *= -returnRate;
	            						break;
	            					case 4:
	            						motionX *= -returnRate;
	            						accelerationX *= -returnRate;
	            						break;
	            					default:
	            						motionX *= -returnRate;
	            						accelerationX *= -returnRate;
	            						break;
	            				}
            					if(getKnifeColor() == 0)
            					{
            						motionX *= 0.3D;
            						motionY *= 0.3D;
            						motionZ *= 0.3D;
            						accelerationX *= 0.3D;
            						accelerationY *= 0.3D;
            						accelerationZ *= 0.3D;
            					}
            				//setKnifeColor(0);
            				//motionX *= -1.000000000149011612D;//移動方向を逆にする
	                		//motionY *= -1.000000000149011612D;
	                		//motionZ *= -1.000000000149011612D;
            				//accelerationX *= -1.00;
	            			//accelerationY *= -1.00;
	            			//accelerationZ *= -1.00;
	            			speed *= -returnRate;
	            			//rotationYaw += 180F;//向きを180度変える
            				supPosX1 = supPosX1 + (supMovingObjectPosition.hitVec.xCoord - supPosX1) * 0.999D;
            				supPosX2 = supPosX1 + motionX;
            				supPosY1 = supPosX1 + (supMovingObjectPosition.hitVec.yCoord - supPosY1) * 0.999D;
            				//supPosY1 = supMovingObjectPosition.hitVec.yCoord;
            				supPosY2 = supPosY1 + motionY;
            				supPosZ1 = supPosX1 + (supMovingObjectPosition.hitVec.zCoord - supPosZ1) * 0.999D;
            				supPosZ2 = supPosZ1 + motionZ;
            				//始点を登録
            				supVec3d1 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX1, supPosY1, supPosZ1);
    						//終点を登録
    						supVec3d2 = worldObj.getWorldVec3Pool().getVecFromPool(supPosX2, supPosY2, supPosZ2);
        					//始点と終点からブロックとの衝突を取得
    						supMovingObjectPosition = worldObj.rayTraceBlocks(supVec3d1, supVec3d2);
            				}
            			//}
            		}
            		if(Math.abs(motionX) < 0.1D)
            		{
            			motionX = 0.0D;
            		}
            		if(Math.abs(motionZ) < 0.1D)
            		{
            			motionZ = 0.0D;
            		}
	            	//prevRotationYaw += 180F;
	                ticksInAir = 0;
	            	ticksExisted = 3;
            		hit = false;
            	}
            	//速度が遅すぎて、かつ、衝突先のブロックが空気でなければ
            	else if(material != Material.air)
            	{
            		//遅すぎる場合はほぼ地面についていると考える　　・・・これ、空中停止バグの原因じゃ・・・
            		//角度を水平にする
            		if(movingObjectPosition.sideHit == 1)
            		{
            			rotationPitch = 0F;
						motionX = movingObjectPosition.hitVec.xCoord - posX;
	                	motionY = movingObjectPosition.hitVec.yCoord - posY;
	                	motionZ = movingObjectPosition.hitVec.zCoord - posZ;
	            		accelerationX = 0.0D;
	            		accelerationY = 0.0D;
	            		accelerationZ = 0.0D;
	            		//当たったブロックとナイフの距離
		            	double f2 = MathHelper.sqrt_double(motionX * motionX + motionY * motionY + motionZ * motionZ);
	            		//めり込んだ分だけ引き戻し
		            	posX -= (motionX / f2) * 0.05000000074505806D;
		            	posY -= (motionY / f2) * 0.05000000074505806D;
		            	posZ -= (motionZ / f2) * 0.05000000074505806D;
	            		//地中チェックをtrue
		            	inGround = true;
	            		//衝突チェックをtrue
		            	hit = true;
	            		//石衝突チェックをtrue
	            		rockhit = true;	
            			ticksInAir = 0;
	            		ticksExisted = 0;
            			setKnifeZAngle(0.0F);
            		}
            		else
            		{
            			//rotationPitch = 0F;
		            	motionX = movingObjectPosition.hitVec.xCoord - posX;
	                	motionY = movingObjectPosition.hitVec.yCoord - posY;
	                	motionZ = movingObjectPosition.hitVec.zCoord - posZ;
	            		accelerationX *= -0.01;
	            		accelerationY *= -0.01;
	            		accelerationZ *= -0.01;
	            		//当たったブロックとナイフの距離
		            	double f2 = MathHelper.sqrt_double(motionX * motionX + motionY * motionY + motionZ * motionZ);
	            		//めり込んだ分だけ引き戻し
		            	posX -= (motionX / f2) * 0.05000000074505806D;
		            	posY -= (motionY / f2) * 0.05000000074505806D;
		            	posZ -= (motionZ / f2) * 0.05000000074505806D;
	            		//地中チェックをtrue
		            	inGround = true;
	            		//衝突チェックをtrue
		            	hit = true;
	            		//石衝突チェックをtrue
	            		rockhit = true;	
            		}
            	}
            }
        	//衝突先のブロックの材質が、硬いものでなく、空気でもなければ
            else if(material != Material.air)
            {
            	//その場で刺さって停止
                motionX = (float)(movingObjectPosition.hitVec.xCoord - posX);
                motionY = (float)(movingObjectPosition.hitVec.yCoord - posY);
                motionZ = (float)(movingObjectPosition.hitVec.zCoord - posZ);
            	accelerationX *= -0.01;
            	accelerationY *= -0.01;
            	accelerationZ *= -0.01;
	            float f2 = MathHelper.sqrt_double(motionX * motionX + motionY * motionY + motionZ * motionZ);//当たったブロックとナイフの距離
	            posX -= (motionX / (double)f2) * 0.05000000074505806D;//めり込んだ分だけ引き戻し
	            posY -= (motionY / (double)f2) * 0.05000000074505806D;
	            posZ -= (motionZ / (double)f2) * 0.05000000074505806D;
	            worldObj.playSoundAtEntity(this, "mob.blaze.hit1", 1.0F, 1.2F / (rand.nextFloat() * 0.2F + 0.9F));
	            inGround = true;
            	ticksExisted = 3;
	            hit = true;
            }
        }
    	
    	//青、赤、緑のナイフなら
    	if(getKnifeColor() != 3 && ticksExisted > 2)
    	{
        	posX += motionX;
        	posY += motionY;
        	posZ += motionZ;
    	}
        float f = MathHelper.sqrt_double(motionX * motionX + motionZ * motionZ);
        rotationYaw = (float)((Math.atan2(motionX, -motionZ) * 180D) / 3.1415927410125732D);
        for (rotationPitch = (float)((Math.atan2(motionY, f) * 180D) / 3.1415927410125732D); rotationPitch - prevRotationPitch < -180F; prevRotationPitch -= 360F) { }
        for (; rotationPitch - prevRotationPitch >= 180F; prevRotationPitch += 360F) { }
        for (; rotationYaw - prevRotationYaw < -180F; prevRotationYaw -= 360F) { }
        for (; rotationYaw - prevRotationYaw >= 180F; prevRotationYaw += 360F) { }
        rotationPitch = prevRotationPitch + (rotationPitch - prevRotationPitch) * 0.2F;
    	
    	if(rockhit == true)
    	{
    		rotationPitch = 0F;
    	}
        
    	rotationYaw = prevRotationYaw + (rotationYaw - prevRotationYaw) * 0.2F;
        float f1 = 0.95F;//減速率
        if (isInWater())//水に入っている場合
        {
            for (int k = 0; k < 4; k++)
            {
                float f3 = 0.25F;
                worldObj.spawnParticle("bubble", posX - motionX * (double)f3, posY - motionY * (double)f3, posZ - motionZ * (double)f3, motionX, motionY, motionZ);
            }

            f1 = 0.8F;//さらに減速率を上げる
        }
        motionX += accelerationX;
        motionY += accelerationY;
        motionZ += accelerationZ;

    	//重力処理
    	motionY -= 0.008 * ticksExisted;
    		
        motionX *= f1;
        motionY *= f1;
        motionZ *= f1;
    	
        setPosition(posX, posY, posZ);
    	
    	/*if(getKnifeColor() == 2)
    	{
    		float ax,ay,az;
    		EntitySilverKnife entitySilverKnife;

   			//rand = random.nextInt(5);//弾の色をランダムで決める
    		ay = (float)motionY;
    		ax = (float)motionX;
    		az = (float)motionZ;
   			entitySilverKnife = new EntitySilverKnife(worldObj, shootingEntity, ax*0.5, ay*0.5, az*0.5, 0.5, 3);
       		//world.playSoundAtEntity(entityplayer, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 4F + 0.8F));//音を出す
       		if(!worldObj.isRemote)//マルチでないなら
       		{
          		//worldObj.spawnEntityInWorld(entitySilverKnife);//銀のナイフを出現させる
       		}
    	}*/
    }

	//衝突したときの処理
	protected void onImpact(MovingObjectPosition movingObjectPosition)
    {
    	//当たったEntityがnullでなければ
    	if ( !worldObj.isRemote && movingObjectPosition.entityHit != null )
        {
        	//当たったEntityがナイフを投げたEntityでなければ
            if ( movingObjectPosition.entityHit != shootingEntity )
            {
            	int damage = 3;
            	//当たったEntityがEntityLivingに属しているなら
            	if(movingObjectPosition.entityHit instanceof EntityLiving)
            	{
            		//当たったEntityをEntityLivingとして扱う
            		EntityLiving entityliving = (EntityLiving)movingObjectPosition.entityHit;
            		//当たったEntityLivingが無敵時間なら
            		if(entityliving.hurtTime > 0)
            		{
            			//強引にダメージを入れ込む（おいw
            			entityliving.heal(-damage);
            			//衝突チェックをtrueにする
            			hit = true;
            		}
            		//当たったEntityLivingが無敵時間でないなら
            		else
            		{
            			//ハート1.5の通常ダメージ
            			movingObjectPosition.entityHit.attackEntityFrom(DamageSource.causeMobDamage(shootingEntity), damage);
            		}
            	}
            }
        }
    }

	//恐らくデータの保存　再度読みこむときにここに保存したものを読み込む
	@Override
    public void writeEntityToNBT(NBTTagCompound nbttagcompound)
    {
        nbttagcompound.setShort("xTile", (short)xTile);
        nbttagcompound.setShort("yTile", (short)yTile);
        nbttagcompound.setShort("zTile", (short)zTile);
        nbttagcompound.setByte("inTile", (byte)inTile);
    	nbttagcompound.setByte("inData", (byte)inData);
    	//nbttagcompound.setByte("shootingEntity;", (byte)inData);
    	
        nbttagcompound.setByte("inGround", (byte)(inGround ? 1 : 0));
    	
    	nbttagcompound.setShort("color", (short)getKnifeColor());
    	nbttagcompound.setShort("zAngle",(short)(getKnifeZAngle() * 10000.0F));
    }

	//保存したデータの読み込み
	@Override
    public void readEntityFromNBT(NBTTagCompound nbttagcompound)
    {
        xTile = nbttagcompound.getShort("xTile");
        yTile = nbttagcompound.getShort("yTile");
        zTile = nbttagcompound.getShort("zTile");
        inTile = nbttagcompound.getByte("inTile") & 0xff;
    	inData = nbttagcompound.getByte("inData") & 0xff;
        inGround = nbttagcompound.getByte("inGround") == 1;
    	
    	setKnifeColor(nbttagcompound.getShort("color"));
    	setKnifeZAngle((float)nbttagcompound.getShort("zAngle") / 10000.0F);
    	
    }
    
    //刺さっているものなら回収可能
    public void onCollideWithPlayer(EntityPlayer par1EntityPlayer)
    {
        if (!worldObj.isRemote && inGround && par1EntityPlayer.inventory.addItemStackToInventory(new ItemStack(mod_thKaguya.silverKnifeItem, 1, getKnifeColor() )))
        {
            worldObj.playSoundAtEntity(this, "random.pop", 0.2F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
            par1EntityPlayer.onItemPickup(this, 1 );
            setDead();
        }
    }

	@Override
    public boolean canBeCollidedWith()
    {
        return true;
    }

	//物体の当たり判定　大きいと透明な判定が邪魔だよ
    public float getCollisionBorderSize()
    {
        return 0.01F;
    }

    public boolean attackEntityFrom(DamageSource damagesource, int i)
    {
        setBeenAttacked();
        if (damagesource.getEntity() != null)
        {
            Vec3 vec3d = damagesource.getEntity().getLookVec();
            if (vec3d != null)
            {
                motionX = vec3d.xCoord;
                motionY = vec3d.yCoord;
                motionZ = vec3d.zCoord;
                accelerationX = motionX * 0.10000000000000001D;
                accelerationY = motionY * 0.10000000000000001D;
                accelerationZ = motionZ * 0.10000000000000001D;
            }
            if (damagesource.getEntity() instanceof EntityLiving)
            {
                shootingEntity = (EntityLiving)damagesource.getEntity();
            }
            return true;
        }
        else
        {
            return false;
        }
    }
    
	//ナイフの色を設定
	public void setKnifeColor(int par1)
	{
		dataWatcher.updateObject(19, Integer.valueOf(par1));
	}
	
	//ナイフの色を返す
	public int getKnifeColor()
	{
		return dataWatcher.getWatchableObjectInt(19);
	}
	
	//ナイフの奥行き方向への角度設定する
	public void setKnifeZAngle(float angle)
	{
		dataWatcher.updateObject(20, Integer.valueOf((int)(angle * 10000.0F)));
	}
	
	//ナイフの奥行き方向への角度を返す
	public float getKnifeZAngle()
	{
		return (float)dataWatcher.getWatchableObjectInt(20) / 10000.0F;
	}

    public float getShadowSize()
    {
        return 0.0F;
    }

    public float getEntityBrightness(float f)
    {
        return 0.0F;
    }

    public int getEntityBrightnessForRender(float f)
    {
        return 0xf000f0;
    }
}
